Subject: [core] rt and if registry question

From: Dave Thaler <[email-masked]>
Date: Wed, 3 Aug 2016 20:40:10 +0000

In some conversations I've been in, I've found that different people read RFC 6690 different ways.

Section 3.1 says:

   The Resource Type 'rt' attribute is an opaque string used to assign

   an application-specific semantic type to a resource.  One can think

   of this as a noun describing the resource.  In the case of a

   temperature resource, this could be, e.g., an application-specific

   semantic type like "outdoor-temperature" or a URI referencing a

   specific concept in an ontology like

   "http://sweet.jpl.nasa.gov/2.0/phys.owl#Temperature".  Multiple

   Resource Types MAY be included in the value of this parameter, each

   separated by a space, similar to the relation attribute.  The

   registry for Resource Type values is defined in Section 7.4<https://tools.ietf.org/html/rfc6690#section-7.4>.

Section 3.2 is similar for 'if' values.

And section 7.4 says:

   For both sub-registries, values starting with the characters "core"

   are registered using the IETF Review registration policy [RFC5226<https://tools.ietf.org/html/rfc5226>].

   All other values are registered using the Specification Required

   policy, which requires review by a designated expert appointed by the

   IESG or their delegate.
...
   o  URIs are reserved for free use as extension values for these
      attributes and MUST NOT be registered.

So the question is, what values can be used _without_ registering.  Clearly the last sentence above
says URIs are allowed.   But it's apparently ambiguous whether other values like "outdoor-temperature"
in 3.1 (or "x.outdoor-temperature" or similar variations) can be used by an application without registering it.
My reading of 3.1 is that registration is required for everything but URIs, but others read section 3.1 differently.
Can the WG clarify what the intent is?

Thanks,
Dave

---

From: Dave Thaler <[email-masked]>
Date: Thu, 4 Aug 2016 15:03:31 +0000

While I'm waiting for an answer to the question below, I'll ask a related question.
Can a prefix be registered?

In the appsawg discussion that led to RFC 7595, we discussed that question in the context of URI scheme names and
the WG consensus was no, there's no such thing as a prefix because it's treated as "an opaque string".

The text quoted from RFC 6690 section 3.1 below also says it's an opaque string, which might be interpreted as
"there's no such thing as a prefix", but then section 7.4 uses "core." as a prefix.   You might say "core.*" is a prefix
for registration purposes but not for purposes of interpreting in code (I don't believe that argument is reasonable though
since once you define it for one purpose, people will use it in code for registration which will then bleed into other
purposes, which is why appsawg disallowed any prefixes).   But if "core.*" is a prefix for registration purposes only,
then the question about whether other prefixes can be registered is a valid question.

Comments?

Dave

From: Dave Thaler
Sent: Wednesday, August 3, 2016 1:40 PM
To: [email-masked]
Subject: rt and if registry question

Section 3.1 says:

And section 7.4 says:

   IESG or their delegate.
...

Thanks,
Dave

---

From: Dave Thaler <[email-masked]>
Date: Fri, 12 Aug 2016 19:03:23 +0000

Resending due to lack of response...
Any of the authors or WG chairs care to state what the intended WG consensus was when RFC 6690 was published?

From: Dave Thaler
Sent: Thursday, August 4, 2016 8:04 AM
To: [email-masked]
Subject: RE: rt and if registry question

Comments?

Dave

From: Dave Thaler
Sent: Wednesday, August 3, 2016 1:40 PM
To: [email-masked]<mailto:[email-masked]>
Subject: rt and if registry question

Section 3.1 says:

And section 7.4 says:

   IESG or their delegate.
...

Thanks,
Dave

---

From: Carsten Bormann <[email-masked]>
Date: Sat, 13 Aug 2016 00:19:29 +0200

Hi Dave,

I'm not the foremost expert on this but I'll give it a try.

> Can a prefix be registered?

No.  There is nothing in section 7.4 of RFC 6690 that would create such
a registry.  (The concept of prefix is used in 4.1 for certain kinds of
searches, but it is really used in its straight computer science meaning
of "the beginning part".)

The text about »values starting with the characters "core"« is about
swapping out the registration policy, there is no other technical change.

Note that the text following (that instructs the designated expert) is
about avoiding the typical vagaries of choosing between link.format and
linkformat and link-format, so it is a matter of style consistency that
is meant to provide more predictability (and this memorability) of the
values being registered.  It uses "core." as an example, not in a
normative way.  ("core." doesn't occur in the entire RFC outside examples.)

Actually, "coresident-sensors" or "coresident.sensors" have the same
special IETF Review policy as "core.foo" -- the policy swap is in effect
for »values starting with the characters "core"«.

I believe the current text of RFC 6690 is sufficient to say all this and
no retroactive analysis of proceedings or mailing lists is required to
come to this conclusion.

Grüße, Carsten

---

From: Dave Thaler <[email-masked]>
Date: Sun, 14 Aug 2016 22:02:01 +0000

Thanks Carsten for the response!  This answers one of the two questions I asked.  I'm still waiting for an
answer on the other question (in short, it was: can you use values other than URIs without
registering, or only URIs?)   The attached email is the one I'm still waiting for an answer on.

I believe I know the answer but since there's apparently confusion, I'd like confirmation on the list either way.

Dave

> -----Original Message-----
> From: Carsten Bormann [mailto:[email-masked]]
> Sent: Friday, August 12, 2016 3:19 PM
> To: Dave Thaler <[email-masked]>
> Cc: [email-masked]
> Subject: Re: [core] rt and if registry question
> 
> Hi Dave,
> 
> No.  There is nothing in section 7.4 of RFC 6690 that would create such a
> registry.  (The concept of prefix is used in 4.1 for certain kinds of searches,
> but it is really used in its straight computer science meaning of "the beginning
> part".)
> 
> Note that the text following (that instructs the designated expert) is about
> avoiding the typical vagaries of choosing between link.format and linkformat
> and link-format, so it is a matter of style consistency that is meant to provide
> more predictability (and this memorability) of the values being registered.  It
> uses "core." as an example, not in a normative way.  ("core." doesn't occur in
> the entire RFC outside examples.)
> 
> Actually, "coresident-sensors" or "coresident.sensors" have the same special
> IETF Review policy as "core.foo" -- the policy swap is in effect for »values
> starting with the characters "core"«.
> 
> I believe the current text of RFC 6690 is sufficient to say all this and no
> retroactive analysis of proceedings or mailing lists is required to come to this
> conclusion.
> 
> Grüße, Carsten

Subject: rt and if registry question
From: Dave Thaler <[email-masked]>
To: "[email-masked]" <[email-masked]>
Date: Wed, 3 Aug 2016 20:40:10 +0000

Section 3.1 says:

And section 7.4 says:

...

Thanks,

Dave

---

From: Michael Koster <[email-masked]>
Date: Wed, 17 Aug 2016 05:34:23 -0700

Hi,

Assuming we must register rt and if values used in OCF, is the CoRE Paramaters Registry an appropriate venue for registration?

http://www.iana.org/assignments/core-parameters/core-parameters.xhtml <http://www.iana.org/assignments/core-parameters/core-parameters.xhtml>

NB in OCF, rt is used for application semantics and there may be hundreds to thousands of rt terms registered with more being added over time.

Will the CoRE Parameters Registry be appropriate for registration of such a large volume of terms, or is there another preferred approach?

Best regards,

Michael

> On Aug 14, 2016, at 3:02 PM, Dave Thaler <[email-masked]> wrote:
> 
> <Mail Attachment.eml>_______________________________________________
> core mailing list
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/core <https://www.ietf.org/mailman/listinfo/core>

---

From: Christian Groves <[email-masked]>
Date: Fri, 26 Aug 2016 14:21:09 +1000

Hello Michael,

Its nice to have one central repository for things but I suspect that 
IANA wouldn't be happy to manage such a large name space.

It could be worthwhile to allow the registration of name spaces in the 
IANA registry (e.g. OIC.* or OCF.*). The registration would include a 
reference to the doucment(s) defining the RTs. The organisation 
registering the namespace is then responsible for the management of the 
"*" part.

At least then somebody coming across a particular rt would know where to 
look for it rather than bodies not registering with IANA because the 
effort to register individual rts is too large.

Regards, Christian

On 17/08/2016 10:34 PM, Michael Koster wrote:
> Hi,
>
> Assuming we must register rt and if values used in OCF, is the CoRE 
> Paramaters Registry an appropriate venue for registration?
>
> http://www.iana.org/assignments/core-parameters/core-parameters.xhtml
>
> NB in OCF, rt is used for application semantics and there may be 
> hundreds to thousands of rt terms registered with more being added 
> over time.
>
> Will the CoRE Parameters Registry be appropriate for registration of 
> such a large volume of terms, or is there another preferred approach?
>
> Best regards,
>
> Michael
>
>
>> On Aug 14, 2016, at 3:02 PM, Dave Thaler <[email-masked] 
>> <mailto:[email-masked]>> wrote:
>>
>> Thanks Carsten for the response!  This answers one of the two 
>> questions I asked.  I'm still waiting for an
>> I believe I know the answer but since there's apparently confusion, 
>> I'd like confirmation on the list either way.
>>
>> Dave
>>
>>> To: Dave Thaler <[email-masked] <mailto:[email-masked]>>
>>> Cc: [email-masked] <mailto:[email-masked]>
>>> special
>> https://www.ietf.org/mailman/listinfo/core
>
>
>
> _______________________________________________
> core mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/core